> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://developer.shipbob.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developer.shipbob.com/_mcp/server.

# Get Transactions by Invoice ID


GET https://api.shipbob.com/2026-01/invoices/{invoiceId}/transactions

The unique identifier of the invoice whose transactions are to be retrieved

Reference: https://developer.shipbob.com/2026-01/api/billing/get-transactions-by-invoice-id

## Authentication

- `Authorization` header (bearer token, required) — Authentication using Personal Access Token (PAT) token
- `Authorization` header (bearer token, required) — OAuth2 authentication using JWT tokens

## Servers

- `https://api.shipbob.com` (https://api.shipbob.com, default)
- `https://sandbox-api.shipbob.com` (https://sandbox-api.shipbob.com)

## Request

### Path parameters

- `invoiceId` (integer, required) — The unique identifier of the invoice whose transactions are to be retrieved.

### Query parameters

- `Cursor` (string, optional) — [Optional] A pagination token used to jump to first, last, next or previous pages. When supplied, it overrides all other filter parameters.
- `PageSize` (integer, optional, default: 100) — Number of transactions to return per page (default is 100, to be entered when API is called for first time). Must be between 1 and 1000.
- `SortOrder` (enum, optional, default: Descending) — Sort order of the results. Valid values: Ascending or Descending (default: Descending).
  - Allowed values: `Ascending`, `Descending`

## Response

### 200

Success

- `first` (string, optional, nullable) — Go to the first page
- `items` (list of object, optional, nullable)
  - `additional_details` (map from string to any, optional, nullable) — Any additional details related to the transaction in a key-value pair format.
  - `amount` (double, optional, nullable) — The charge amount for the transaction.
  - `charge_date` (string, optional, nullable) — The date when the transaction was charged.
  - `currency_code` (string, optional, nullable) — The ISO currency code (e.g., USD, EUR) for the transaction.
  - `fulfillment_center` (string, optional, nullable) — The name or code of the fulfillment center involved in the transaction.
  - `invoice_date` (string, optional, nullable) — The date the invoice was generated.
  - `invoice_id` (integer, optional, nullable) — The unique identifier of the invoice associated with this transaction.
  - `invoice_type` (enum, optional, nullable) — The type or category of the invoice.
    - Allowed values: `Shipping`, `Inbound Fee`, `WarehouseStorage`, `AdditionalFee`, `Return`, `Credits`, `BalanceAdjustment`, `Payment`
  - `invoiced_status` (boolean, optional, nullable) — Indicates whether the transaction has been invoiced. True if billed, false if unbilled.
  - `reference_id` (string, optional, nullable) — A unique reference identifier associated with the transaction.
  - `reference_type` (enum, optional, nullable) — The type of reference associated with the reference ID.
    - Allowed values: `Shipment`, `Return`, `WRO`, `URO`, `Ticket Number`, `FC`, `LPN Reference`, `Transfer Plan`
  - `taxes` (list of object, optional, nullable) — A list of tax details applied to the transaction, if any exist.
    - `tax_amount` (double, optional) — Tax amount charged for this tax type.
    - `tax_rate` (double, optional) — Tax rate applied as a percentage.
    - `tax_type` (string, optional, nullable) — Type of tax applied.
  - `transaction_fee` (string, optional, nullable) — The fee type associated with the transaction. To get all available transaction fees, use the '/transaction-fees' endpoint.
  - `transaction_id` (string, optional, nullable) — The unique identifier for the transaction.
  - `transaction_type` (enum, optional, nullable) — The classification or nature of the transaction.
    - Allowed values: `Charge`, `Refund`, `Credit`, `Payment`, `BalanceAdjustment`
- `last` (string, optional, nullable) — Go to the Last page
- `next` (string, optional, nullable) — Go to the Next page
- `prev` (string, optional, nullable) — Go to the Previous page

## Errors

### 401 Unauthorized Error

Authorization missing or invalid

- `any`

### 403 Forbidden Error

The provided credentials are not authorized to access this resource

- `any`

### 404 Not Found Error

Not Found

- `detail` (string, optional, nullable)
- `instance` (string, optional, nullable)
- `status` (integer, optional, nullable)
- `title` (string, optional, nullable)
- `type` (string, optional, nullable)

### 500 Internal Server Error

Server Error

- `any`

## Examples

**Response**

```json
{
  "first": "f8cUk/xJkbeYp2L8oHqxL2hFiGz3qjre",
  "items": [
    {
      "additional_details": {
        "comment": "TestInvoice"
      },
      "amount": 0.09,
      "charge_date": "2025-01-01",
      "currency_code": "USD",
      "fulfillment_center": "Altona VIC",
      "invoice_date": "2025-01-01",
      "invoice_id": 12345,
      "invoice_type": "Shipping",
      "invoiced_status": true,
      "reference_id": "12345",
      "reference_type": "Shipment",
      "taxes": [
        {
          "tax_amount": 0.01,
          "tax_rate": 10,
          "tax_type": "GST"
        }
      ],
      "transaction_fee": "Shipping",
      "transaction_id": "01AN4Z07BY79KA1307SR9X4MV3",
      "transaction_type": "Charge"
    }
  ],
  "last": "f8cUk/xJkbeYp2L8oHqxL2hFiGz3qjqt",
  "next": "f8cUk/xjhyEYp2L8oHqxL2hFiGz3qjqt",
  "prev": "f8cUk/xJkbeYp2L8oHqxL2hFiGz3qjcc"
}
```

**SDK Code**

```python default
import requests

url = "https://api.shipbob.com/2026-01/invoices/12345/transactions"

querystring = {"Cursor":"f8cUk/xJkbeYp2fCr3yJJvL8oHqxL2hFiGz3qjqtkQ5Q0+BVMffFoIfoqzOkEsAw","PageSize":"100","SortOrder":"Ascending"}

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers, params=querystring)

print(response.json())
```

```javascript default
const url = 'https://api.shipbob.com/2026-01/invoices/12345/transactions?Cursor=f8cUk%2FxJkbeYp2fCr3yJJvL8oHqxL2hFiGz3qjqtkQ5Q0%2BBVMffFoIfoqzOkEsAw&PageSize=100&SortOrder=Ascending';
const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go default
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.shipbob.com/2026-01/invoices/12345/transactions?Cursor=f8cUk%2FxJkbeYp2fCr3yJJvL8oHqxL2hFiGz3qjqtkQ5Q0%2BBVMffFoIfoqzOkEsAw&PageSize=100&SortOrder=Ascending"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby default
require 'uri'
require 'net/http'

url = URI("https://api.shipbob.com/2026-01/invoices/12345/transactions?Cursor=f8cUk%2FxJkbeYp2fCr3yJJvL8oHqxL2hFiGz3qjqtkQ5Q0%2BBVMffFoIfoqzOkEsAw&PageSize=100&SortOrder=Ascending")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java default
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.shipbob.com/2026-01/invoices/12345/transactions?Cursor=f8cUk%2FxJkbeYp2fCr3yJJvL8oHqxL2hFiGz3qjqtkQ5Q0%2BBVMffFoIfoqzOkEsAw&PageSize=100&SortOrder=Ascending")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php default
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.shipbob.com/2026-01/invoices/12345/transactions?Cursor=f8cUk%2FxJkbeYp2fCr3yJJvL8oHqxL2hFiGz3qjqtkQ5Q0%2BBVMffFoIfoqzOkEsAw&PageSize=100&SortOrder=Ascending', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp default
using RestSharp;

var client = new RestClient("https://api.shipbob.com/2026-01/invoices/12345/transactions?Cursor=f8cUk%2FxJkbeYp2fCr3yJJvL8oHqxL2hFiGz3qjqtkQ5Q0%2BBVMffFoIfoqzOkEsAw&PageSize=100&SortOrder=Ascending");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift default
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.shipbob.com/2026-01/invoices/12345/transactions?Cursor=f8cUk%2FxJkbeYp2fCr3yJJvL8oHqxL2hFiGz3qjqtkQ5Q0%2BBVMffFoIfoqzOkEsAw&PageSize=100&SortOrder=Ascending")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```